create procedure CHANGESTATUSINDOC (
    IDDOC integer,
    TOSTATUS integer)
as
declare variable RESERVEINVOICE integer;
declare variable WASRESERVEINVOICE_OUT integer;
declare variable LASTIDDOCINVOICE_WRI integer;
declare variable REMEMBERTEMPKART integer;
declare variable MAKELABELIN integer;
declare variable ISINVOICE integer;
declare variable LOOKINVOICE integer;
declare variable IDSECTION_INVOICE integer;
declare variable IDSECTION1 integer;
declare variable IDSECTION2 integer;
declare variable IDMOVES integer;
declare variable HAS_ROW1 integer;
declare variable HAS_ROW2 integer;
declare variable DOC_ID integer;
declare variable IDDOCBACK integer;
declare variable IDROWBACK integer;
declare variable LASTSUMMABACK double precision;
declare variable LASTIDDOCBACK integer;
declare variable LASTKOLBACK double precision;
declare variable IDDOCINVOICE integer;
declare variable IDROWINVOICE integer;
declare variable LASTIDDOCINVOICE integer;
declare variable LASTSUMMAINVOICEOUT double precision;
declare variable LASTKOLINVOICEOUT double precision;
declare variable CNT integer;
declare variable KOEF integer;
declare variable IDSHOP integer;
declare variable IDLABEL integer;
declare variable LABEL_STATUS integer;
declare variable LABEL_ISSERVICE integer;
declare variable MAININVOICE_STATUS integer;
declare variable SUMMA double precision;
declare variable KOL double precision;
declare variable KOL2 double precision;
declare variable KOL3 double precision;
declare variable KOLINVOICE double precision;
declare variable KART_KOLINVOICE double precision;
declare variable TEMPKART_KOLINVOICE double precision;
declare variable TEMPKART_KOLINVOICE0 double precision;
declare variable TEMPKART_KOL double precision;
declare variable DOCINVOICE_KOL double precision;
declare variable DOC_KOLINVOICEOUT double precision;
declare variable DOC_KOLNOACTUAL double precision;
declare variable K_INVOICE double precision;
declare variable KOLTEK double precision;
declare variable ISBACK integer;
declare variable IDROWOUT integer;
declare variable IDDOCOUT integer;
declare variable WASRESERVEINVOICE_OUT_INVOICE integer;
begin
  /*   
  1.   
  2.  <   > 
  3. ------     (Label.DateSeb)
  4.       -   < >  
  5. ------  :       (    TEMPKARTBYBATCH)
  6.   :   <>  ,    -  
  7.   :   <>  
  */
  LookINVOICE = 0;
  select Main.IdSpr1, Main.IdSpr2, Main.IdMoves, Main.IsInvoice, t1.Has_row, t2.Has_Row
  from Main
  left outer join Type_oper t1 on t1.Id = Main.IdType1
  left outer join Type_oper t2 on t2.Id = Main.idtype2
  where main.Id = :IdDoc
  into :IdSection1, :IdSection2, :IdMoves, :IsInvoice, :Has_Row1, :Has_Row2;
  if (IsInvoice is null) then
    IsInvoice = 0;
  if (Has_Row1 is null) then
    Has_Row1 = 0;
  if (Has_Row2 is null) then
    Has_Row2 = 0;
  if (IdSection1 is null) then
    IdSection1 = 0;
  if (IdSection2 is null) then
    IdSection2 = 0;
  if (Has_Row1 <= 0) then
    IdSection1 = 0;
  if (Has_Row2 <= 0) then
    IdSection2 = 0;

  select Moves.remembertempkartbyexit, Moves.makelabelin, Moves.doreserveininvoice
  from moves
  where Moves.Id = :IdMoves
  into :RememberTempKart, :MakeLabelIn, :ReserveInvoice;
  if (RememberTempKart is null) then
    RememberTempKart = 0;
  if (MakeLabelIn is null) then
    MakeLabelIn = 0;
  if (ReserveInvoice is null) then
    ReserveInvoice = 0;

  IsBack = 0;
  LastSummaInvoiceOut = 0;
  LastKolInvoiceOut = 0;
  LastIdDocInvoice = 0;
  LastIdDocInvoice_wri = 0;

  LastSummaBack = 0;
  LastKolBack = 0;
  LastIdDocBack = 0;
  wasreserveinvoice_out = 0;

  for select Doc.Id, Doc.IdLabel, Doc.Kol, doc.Summa, label.status, labelcategory.isservice, Doc.IdDocBack, Doc.IdRowBack, Doc.iddocinvoice, Doc.IdRowInvoice,
             Doc.KolInvoiceOut, Doc.KolNoactual
      from Doc
      left outer join Label on Label.Id = Doc.IdLabel
      left outer join labelcategory on labelcategory.Id = label.idcategory
      where Doc.IdDoc = :IdDoc
      order by Doc.iddocinvoice + 0, Doc.IdDocBack + 0, Doc.IdLabel + 0
      into :Doc_Id, :IdLabel, :Kol, :Summa, :Label_Status, :Label_IsService, :IdDocBack, :IdRowBack, :IdDocInvoice, :IdRowInvoice, :Doc_KolInvoiceOut,
           :Doc_KolNoActual
  do
  begin
    if (IdDocInvoice is null) then
      IdDocInvoice = 0;/* :         */
    if ((IdDocInvoice <> LastIdDocInvoice_wri) and
        (IdDocInvoice > 0)) then
    begin
      select moves.doreserveininvoice
      from main
      left outer join moves on moves.Id = main.IdMoves
      where Main.id = :IdDocInvoice
      into :wasreserveinvoice_out;
      LastIdDocInvoice_wri = IdDocInvoice;
      if (wasreserveinvoice_out is null) then
        wasreserveinvoice_out = 0;
    end
    if (IdDocInvoice = 0) then
      wasreserveinvoice_out = 0;

    if (Label_IsService is null) then
      Label_IsService = 0;
    if ((Label_Status < 0) and
        (Label_Status > -10)) then
    begin
      update Label
      set Status = 0
      where Id = :IdLabel;
    end

    KolInvoice = 0;
    DocInvoice_Kol = 0;
    Kart_KolInvoice = 0;
    /*   --------------------------------------------------------------------------
   <>    (    - /)
   --------------------------------------------------------------------------*/
    if (IdDocInvoice is null) then
      IdDocInvoice = 0;
    Koef = 1;
    if (ToStatus = 0) then
      Koef = -1;
    if ((LastIdDocInvoice > 0) and
        (IdDocInvoice <> LastIdDocInvoice)) then
    begin
      update main
      set main.summainvoiceout = main.summainvoiceout + :LastSummaInvoiceOut * :Koef,
          main.kolinvoiceout = main.kolinvoiceout + :LastKolInvoiceOut * :Koef
      where Main.Id = :LastIdDocInvoice;
      LastKolInvoiceOut = 0;
      LastSummaInvoiceOut = 0;
    end
    if ((IdDocInvoice > 0) and
        (IdDocInvoice <> LastIdDocInvoice)) then
    begin
      select Main.Status, Main.IdSpr2, moves.doreserveininvoice
      from Main
      left outer join moves on moves.id = main.idmoves
      where Main.Id = :IdDocInvoice
      into :MAININVOICE_STATUS, :IDSECTION_Invoice, :Wasreserveinvoice_out_invoice;
    end
    if (Wasreserveinvoice_out_invoice is null) then
      Wasreserveinvoice_out_invoice = 0;
    LastIdDocInvoice = IdDocInvoice;
    if (IdDocInvoice > 0) then
    begin
      KolInvoice = Kol;
      if (ToStatus = 0) then
      begin
        K_Invoice = null;
        select DocInvoice.Kol
        from docinvoice
        where DocInvoice.IdRow = :DOC_ID
        into :K_Invoice;
        if (not(K_Invoice is null)) then
        begin
          KolInvoice = K_Invoice;
          DocInvoice_Kol = K_Invoice;
          delete from docinvoice
          where DocInvoice.IdRow = :DOC_ID;
        end
      end
      if (ToStatus = 1) then
      begin
        K_Invoice = 0;
        select Doc.Kol - Doc.kolinvoiceout - Doc.KolNoActual
        from doc
        where Doc.Id = :IdRowInvoice
        into :K_Invoice;
        if (Kol > K_Invoice) then
        begin
          KolInvoice = K_Invoice;
          DocInvoice_Kol = K_Invoice;
          insert into DocInvoice (IdRow, IdRowInvoice, Kol)
          values (:Doc_Id, :IDROWINVOICE, :kolInvoice);
        end
      end
      LastSummaInvoiceOut = LastSummaInvoiceOut + KolInvoice * Summa / Kol;
      LastKolInvoiceOut = LastKolInvoiceOut + KolInvoice;
      update Doc
      set Doc.kolinvoiceout = doc.kolinvoiceout + :KolInvoice * :Koef
      where Doc.Id = :IdRowInvoice;
    end

    /*   --------------------------------------------------------------------------
 TEMPKART -       (  -   )
   --------------------------------------------------------------------------*/
    if ((ToStatus = 0) and
        (RememberTempKart = 1) and
        (IdSection2 > 0) and
        (IsInvoice = 0)) then
    begin
      if ((IdDocInvoice = 0) or (wasreserveinvoice_out = 0)) then
      begin /*   -     c   */
        insert into TempKart (IdSection, IdLabel, Kol, IdDoc, DocIsOpen, IdRow)
        values (:IdSection2, :IdLabel, :Kol, :IdDoc, 0, :Doc_Id);
      end
      if ((IdDocInvoice > 0) and
          (wasreserveinvoice_out = 1)) then
      begin /*   -       */
        TempKart_Kol = kol;
        if (MainInvoice_Status > 0) then
        begin /*  - */
          TempKart_Kol = 0;
          if (DocInvoice_Kol > 0) then
          begin
            TempKart_Kol = DocInvoice_Kol;
          end
        end
        if (DocInvoice_Kol > 0) then
        begin
          insert into TempKart (IdSection, IdLabel, Kol, IdDoc, DocIsOpen, IdRow, IdDocInvoice, IdRowInvoice)
          values (:IdSection2, :IdLabel, :DocInvoice_Kol, :IdDoc, 0, :Doc_Id, :IdDocInvoice, :IdRowInvoice);
        end
        if (TempKart_Kol - DocInvoice_Kol > 0) then
        begin
          insert into TempKart (IdSection, IdLabel, Kol, IdDoc, DocIsOpen, IdRow)
          values (:IdSection2, :IdLabel, :TempKart_Kol - :DocInvoice_Kol, :IdDoc, 0, :Doc_Id);
        end
      end
    end
    /*   --------------------------------------------------------------------------
 TEMPKART -       (  -   )
   --------------------------------------------------------------------------*/
    TempKart_KolInvoice = Kol - Doc_KolNoActual - Doc_KolInvoiceOut;
    if ((ToStatus = 0) and
        (RememberTempKart = 1) and
        (IdSection2 > 0) and
        (IsInvoice = 1)) then
    begin
      for select d2.Kol, d2.Id, m2.Id,
                 (select sum(TempKart.Kol)
                  from TempKart
                  where TempKart.IdRow = d2.Id and
                        TempKart.IdRowInvoice = d2.IdRowInvoice)
          from Doc d2
          left outer join Main m2 on m2.Id = d2.IdDoc
          where d2.IdRowInvoice = :Doc_Id and
                m2.Status + 0 = 0
          into :Kol2, :IdRowOut, :IdDocOut, :Kol3
      do
      begin
        if (Kol2 is null) then
          Kol2 = 0;
        if (Kol2 > TempKart_KolInvoice) then
          Kol2 = TempKart_KolInvoice;
        if (Kol3 is null) then
          Kol3 = 0;
        TempKart_KolInvoice0 = Kol2 - Kol3;
        if (TempKart_KolInvoice0 <> 0) then
        begin
          /*     TempKart         */
          insert into TempKart (IdSection, IdLabel, Kol, IdDoc, DocIsOpen, IdRow, IdDocInvoice, IdRowInvoice)
          values (:IdSection2, :IdLabel, :TempKart_KolInvoice0, :IdDocOut, 0, :IdRowOut, :IdDoc, :Doc_Id);
        end
        TempKart_KolInvoice = TempKart_KolInvoice - TempKart_KolInvoice0;
      end
      if (TempKart_KolInvoice > 0) then
      begin
        insert into TempKart (IdSection, IdLabel, Kol, IdDoc, DocIsOpen, IdRow)
        values (:IdSection2, :IdLabel, :TempKart_KolInvoice, :IdDoc, 0, :Doc_Id);
      end
    end
    /*   --------------------------------------------------------------------------
  ,      
   --------------------------------------------------------------------------*/
    if (Label_IsService = 0) then
    begin
      if ((IdSection1 > 0) and
          (IsInvoice = 0)) then
      begin
        Koef = 1;
        if (ToStatus = 0) then
          Koef = -1;
        KolTek = 0;
        if (IsInvoice = 0) then
          KolTek = Kol * Koef;
        select count(*)
        from Kart
        where Kart.IdLabel = :IdLabel and
              IdSection = :IdSection1
        into :cnt;
        if (cnt > 0) then
        begin
          update Kart
          set KolTek = KolTek + :KolTek
          where IdLabel = :IdLabel and
                IdSection = :IdSection1;
        end
        else
        begin
          select Type_oper.IdShop
          from CommonSpr
          left outer join Type_oper on Type_oper.Type_spr = CommonSpr.Id_Type and
                Type_oper.Has_row = 1
          where CommonSpr.Id = :IdSection1 and
                Type_oper.Has_row = 1
          into :IdShop;
          if (IdShop > 0) then
          begin
            insert into kart (IdSection, IdLabel, Kol0, Koltek, KolInvoice, IdShop)
            values (:IdSection1, :IdLabel, 0, :KolTek, 0, :IdShop);
          end
        end
      end /*  */
      /*   */
      if (IdSection2 > 0) then
      begin
        Koef = 1;
        if (ToStatus = 1) then
          Koef = -1;
        KolTek = 0;
        Kart_KolInvoice = 0;
        if (IsInvoice = 0) then
        begin
          KolTek = Kol * Koef;
          if ((IdRowInvoice > 0) and
              (wasreserveinvoice_out = 1)) then
          begin
            Kart_KolInvoice = Kol * Koef;
            if (DocInvoice_Kol <> 0) then
              Kart_KolInvoice = DocInvoice_Kol * Koef;
          end
        end
        if ((IsInvoice = 1) and
            (ReserveINVOICE = 1)) then
          Kart_KolInvoice = (Kol - Doc_KolInvoiceOut - Doc_KolNoActual) * (-1) * Koef;
        if ((MainInvoice_Status = 0) and
            (Wasreserveinvoice_out_invoice = 1)) then
          Kart_KolInvoice = 0;
        if (IDSECTION_Invoice is null) then
          IDSECTION_Invoice = 0;
        if ((IDSECTION_Invoice <> IdSection2) and
            (IDSECTION_Invoice <> 0) and
            (Kart_KolInvoice <> 0)) then
        begin
          /*        */
          /*    */
          select count(*)
          from Kart
          where Kart.IdLabel = :IdLabel and
                IdSection = :IdSection2
          into :cnt;
          if (cnt > 0) then
          begin
            update Kart
            set KolTek = KolTek + :Koltek
            where IdLabel = :IdLabel and
                  IdSection = :IdSection2;
          end
          else
          begin
            select Type_oper.IdShop
            from CommonSpr
            left outer join Type_oper on Type_oper.Type_spr = CommonSpr.Id_Type and
                  Type_oper.Has_row = 1
            where CommonSpr.Id = :IdSection2 and
                  Type_oper.Has_row = 1
            into :IdShop;
            if (IdShop > 0) then
            begin
              insert into kart (IdSection, IdLabel, Kol0, Koltek, KolInvoice, IdShop)
              values (:IdSection2, :IdLabel, 0, :KolTek, 0, :IdShop);
            end
          end
          /*    */
          select count(*)
          from Kart
          where Kart.IdLabel = :IdLabel and
                IdSection = :IDSECTION_Invoice
          into :cnt;
          if (cnt > 0) then
          begin
            update Kart
            set KolInvoice = KolInvoice + :KART_KOLINVOICE
            where IdLabel = :IdLabel and
                  IdSection = :IDSECTION_Invoice;
          end
          else
          begin
            select Type_oper.IdShop
            from CommonSpr
            left outer join Type_oper on Type_oper.Type_spr = CommonSpr.Id_Type and
                  Type_oper.Has_row = 1
            where CommonSpr.Id = :IDSECTION_Invoice and
                  Type_oper.Has_row = 1
            into :IdShop;
            if (IdShop > 0) then
            begin
              insert into kart (IdSection, IdLabel, Kol0, Koltek, KolInvoice, IdShop)
              values (:IdSection2, :IdLabel, 0, 0, :KART_KOLINVOICE, :IdShop);
            end
          end
        end
        else
        begin
          /*             -   */
          select count(*)
          from Kart
          where Kart.IdLabel = :IdLabel and
                IdSection = :IdSection2
          into :cnt;
          if (cnt > 0) then
          begin
            update Kart
            set KolTek = KolTek + :Koltek,
                KolInvoice = KolInvoice + :Kart_KolInvoice
            where IdLabel = :IdLabel and
                  IdSection = :IdSection2;
          end
          else
          begin
            select Type_oper.IdShop
            from CommonSpr
            left outer join Type_oper on Type_oper.Type_spr = CommonSpr.Id_Type and
                  Type_oper.Has_row = 1
            where CommonSpr.Id = :IdSection2 and
                  Type_oper.Has_row = 1
            into :IdShop;
            if (IdShop > 0) then
            begin
              insert into kart (IdSection, IdLabel, Kol0, Koltek, KolInvoice, IdShop)
              values (:IdSection2, :IdLabel, 0, :KolTek, :Kart_KolInvoice, :IdShop);
            end
          end
        end
      end /*    */
    end /*   */

    /*   --------------------------------------------------------------------------
  <>  ,    -  
   --------------------------------------------------------------------------*/
    if (IsInvoice = 0) then
    begin
      if (IdDocBack is null) then
        IdDocBack = 0;
      Koef = 1;
      if (ToStatus = 0) then
        Koef = -1;
      if ((LastIdDocBack > 0) and
          (IdDocBack <> LastIdDocBack)) then
      begin
        update main
        set main.summaBack = main.summaBack + :LastSummaBack * :Koef
        where Main.Id = :LastIdDocBack;
        LastKolBack = 0;
        LastSummaBack = 0;
      end
      LastIdDocBack = IdDocBack;
      if (IdDocBack > 0) then
      begin
        LastSummaBack = LastSummaBack + Summa;
        LastKolBack = LastKolBack + Kol;
        update Doc
        set Doc.kolBack = doc.kolBack + :Kol * :Koef
        where Doc.Id = :IdRowBack;
      end
    end /*    */
  end /*     */
  if (IdDocInvoice is null) then
    IdDocInvoice = 0;
  Koef = 1;
  if (ToStatus = 0) then
    Koef = -1;
  if (LastIdDocInvoice > 0) then
  begin
    update main
    set main.summainvoiceout = main.summainvoiceout + :LastSummaInvoiceOut * :Koef,
        main.kolinvoiceout = main.kolinvoiceout + :LastKolInvoiceOut * :Koef
    where Main.Id = :LastIdDocInvoice;
  end

  /*   --------------------------------------------------------------------------
  <>  ,    -  
   --------------------------------------------------------------------------*/
  if (IsInvoice = 0) then
  begin
    if (IdDocBack is null) then
      IdDocBack = 0;
    Koef = 1;
    if (ToStatus = 0) then
      Koef = -1;
    if (LastIdDocBack > 0) then
    begin
      update main
      set main.summaBack = main.summaBack + :LastSummaBack * :Koef
      where Main.Id = :LastIdDocBack;
    end
  end

  /*   --------------------------------------------------------------------------
 <   > 
   --------------------------------------------------------------------------*/
  if ((ToStatus = 1) and
      (MAKELABELIN = 1)) then
  begin
    insert into LabelIn (IdLabel, IdSpr)
    select Doc.IdLabel, Main.IdSpr2
    from Main
    left outer join Doc on Doc.IdDoc = Main.Id
    left outer join LabelIn on LabelIn.IdLabel = Doc.IdLabel and
          LabelIn.IdSpr = Main.IdSpr2
    where Main.Id = :IdDoc and
          LabelIn.IdLabel is null and
          (Main.idspr2 + 0 > 0) and
          (doc.idlabel + 0 > 0);
  end

  /*   --------------------------------------------------------------------------
TEMPKART
   --------------------------------------------------------------------------*/
  if (ToStatus = 1) then
  begin
    delete from TempKart
    where IdDoc = :IdDoc or IdDocInvoice = :IdDoc;
  end /*   , TempKart  */

end
